---
title: Reflect.has()
slug: Web/JavaScript/Reference/Global_Objects/Reflect/has
tags:
  - ECMAScript 2015
  - JavaScript
  - Method
  - Reference
  - Reflect
---
<div>{{JSRef}}</div>

<p>The static <strong><code>Reflect.has()</code></strong> method works like the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a> as a function.</p>

<div>{{EmbedInteractiveExample("pages/js/reflect-has.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Reflect.has(<var>target</var>, <var>propertyKey</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>target</var></code></dt>
 <dd>The target object in which to look for the property.</dd>
 <dt><code><var>propertyKey</var></code></dt>
 <dd>The name of the property to check.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Boolean")}} indicating whether or not the <code><var>target</var></code> has the property.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>A {{jsxref("TypeError")}}, if <code><var>target</var></code> is not an {{jsxref("Object")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>Reflect.has</code> method allows you to check if a property is in an object. It works like the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a> as a function.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Reflect.has">Using Reflect.has()</h3>

<pre class="brush: js notranslate">Reflect.has({x: 0}, 'x')  // true
Reflect.has({x: 0}, 'y')  // false

// returns true for properties in the prototype chain
Reflect.has({x: 0}, 'toString')

// Proxy with .has() handler method
obj = new Proxy({}, {
  has(t, k) { return k.startsWith('door')  }
});
Reflect.has(obj, 'doorbell')  // true
Reflect.has(obj, 'dormitory')  // false
</pre>

<p><code>Reflect.has</code> returns <code>true</code> for any inherited properties, like the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a>:</p>

<pre class="brush: js notranslate">const a = {foo: 123}
const b = {__proto__: a}
const c = {__proto__: b}
// The prototype chain is: c -&gt; b -&gt; a
Reflect.has(c, 'foo') // true
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-reflect.has', 'Reflect.has')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Reflect.has")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Reflect")}}</li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/in"><code>in</code> operator</a></li>
</ul>
